/**
 * $Id$
 */
package jp.co.powerbeans.common.swt;

import java.io.Serializable;

/**
 * Config, アプリケーションの１つの設定
 * 
 * @author amonden
 * @create 2006/12/21
 */
public class Config implements Serializable {

  /**
   * 
   */
  private static final long serialVersionUID = 1L;
  
  /**
   * configId
   */
  private int configId;
  
  /**
   * グループID
   */
  private int configGrpId;
  
  /**
   * 設定名
   */
  private String name;
  /**
   * 値
   */
  private String value;
  
  /**
   * 表示ラベル
   */
  private String label;
  
  /**
   * 画面表示コントロール
   */
  private ControlType controlType;

  public Config() {
    
  }
  /**
   * @param configId
   * @param configGrpId
   * @param name
   * @param value
   * @param label
   * @param controlType
   */
  public Config(int configId, int configGrpId, String name, String value, String label, ControlType controlType) {
    super();
    this.configId = configId;
    this.configGrpId = configGrpId;
    this.name = name;
    this.value = value;
    this.label = label;
    this.controlType = controlType;
  }
  /**
   * @return name を戻します。
   */
  public String getName() {
    return this.name;
  }
  /**
   * @param name 設定する name。
   */
  public void setName(String name) {
    this.name = name;
  }
  /**
   * @return value を戻します。
   */
  public String getValue() {
    return this.value;
  }
  /**
   * @param value 設定する value。
   */
  public void setValue(String value) {
    this.value = value;
  }
  /**
   * @return classNaviConfigId を戻します。
   */
  public int getConfigId() {
    return this.configId;
  }
  /**
   * @param classNaviConfigId 設定する classNaviConfigId。
   */
  public void setConfigId(int classNaviConfigId) {
    this.configId = classNaviConfigId;
  }
  /**
   * @return configGrpId を戻します。
   */
  public int getConfigGrpId() {
    return this.configGrpId;
  }
  /**
   * @param configGrpId 設定する configGrpId。
   */
  public void setConfigGrpId(int configGrpId) {
    this.configGrpId = configGrpId;
  }
  /**
   * @return controlType を戻します。
   */
  public ControlType getControlType() {
    return this.controlType;
  }
  /**
   * @param controlType 設定する controlType。
   */
  public void setControlType(ControlType controlType) {
    this.controlType = controlType;
  }
  /**
   * @return label を戻します。
   */
  public String getLabel() {
    return this.label;
  }
  /**
   * @param label 設定する label。
   */
  public void setLabel(String label) {
    this.label = label;
  }
}

