/**
 * $Id$
 */
package jp.co.powerbeans.common.swt;

import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Text;

/**
 * ConfigSetType
 * 
 * @author amonden
 * @create 2006/12/27
 */
public enum ControlType {
  TEXT {
    public Control addControl(Composite comp, String name, String default_value) {
      Text text = PBControlUtil.addTextBox(comp, SWT.LEFT, 1, 20);
      text.setText(default_value);
      return text;
    }
    
    public String getValue(Control control) {
      return ((Text)control).getText();
    }
  }
  
  ,COMBO {
    public Control addControl(Composite comp, String name, String default_value) {
      return null;
//      return PBControlUtil.addTextBox(comp, SWT.RIGHT, 1, 30);
    }
    public String getValue(Control control) {
      return ((Combo)control).getText();
    }
  }
  
  ,EDIT_COMBO {
    public Control addControl(Composite comp, String name, String default_value) {
      return null;
//      return PBControlUtil.addTextBox(comp, SWT.RIGHT, 1, 30);
    }
    public String getValue(Control control) {
      return ((Combo)control).getText();
    }
  }
  
  ,RADIO {
    public Control addControl(Composite comp, String name, String default_value) {
      return null;
//      return PBControlUtil.addTextBox(comp, SWT.RIGHT, 1, 30);
    }
    public String getValue(Control control) {
      return ((Button)control).getText();
    }
  };

  public abstract Control addControl(Composite comp, String name, String default_value);

  /**
   * @param control
   * @return
   */
  public abstract String getValue(Control control);


}
