/**
 * $Id: $
 */
package jp.co.powerbeans.common.swt;

import org.eclipse.swt.events.KeyEvent;
import org.eclipse.swt.events.KeyListener;
import org.eclipse.swt.widgets.Control;

/**
 * codeに一致するキーが入力された場合
 * コントロールをフォーカスする
 * 
 * @author amonden
 * @create 2007/01/11
 */
public class FocusKeyListener implements KeyListener {

  /**
   * コントロール
   */
  private Control control;
  /**
   * 対象キーコード
   */
  private int code;

  /**
   * @param control
   * @param code
   */
  public FocusKeyListener(Control control, int code) {
    this.control = control;
    this.code = code;
  }

  /* (非 Javadoc)
   * @see org.eclipse.swt.events.KeyListener#keyPressed(org.eclipse.swt.events.KeyEvent)
   */
  public void keyPressed(KeyEvent key_event) {
    if (key_event.getSource() == control && key_event.keyCode == code) {
      this.control.forceFocus();
    }
  }

  /* (非 Javadoc)
   * @see org.eclipse.swt.events.KeyListener#keyReleased(org.eclipse.swt.events.KeyEvent)
   */
  public void keyReleased(KeyEvent key_event) {
  }

}
