/**
 * $Id$
 */
package jp.co.powerbeans.common.swt;

import jp.co.powerbeans.common.db.DBManager;

import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Control;


/**
 * PBConfigSwt.
 * 汎用的な設定画面
 * 
 * @author amonden
 * @create 2006/12/27
 */
public class PBConfigSwt extends PBSwt {

  private static final String TITLE = "設定";

  static final int WINDOW_WIDTH = 450;

  static final int WINDOW_HEIGTH = 100;

  static final int BUTTON_WIDTH = WINDOW_WIDTH;

  static final int BUTTON_HEIGTH = 30;

  private Config[] configs;

  private Class masterCls;

  private Control[] controls;
  
  /**
   * @param menu_items
   */
  public PBConfigSwt(Config[] configs) {
    this(configs, TITLE);
  }

  /**
   * @param config_sets
   * @param title2
   */
  public PBConfigSwt(Config[] init_configs, String title) {
    
    // DBに存在する場合はDBから取得
    this.configs = init_configs;
    
    if (init_configs != null && init_configs.length > 0) {
      Config[] configs_db = (Config[]) DBManager.findBy(Config.class, "configGrpId = " + init_configs[0].getConfigGrpId(), "configId");
      if (configs_db != null && configs_db.length > 0) {
        this.configs = configs_db;
      }
    }
    
    createSShell(title, WINDOW_WIDTH, WINDOW_HEIGTH + BUTTON_HEIGTH * this.configs.length, true);
    setGridLayout(2);
    
    this.controls = new Control[this.configs.length];
    for (int i = 0; i < this.configs.length; i++) {
      PBControlUtil.createLabel(this.sShell, configs[i].getLabel(), SWT.RIGHT, SWT.CENTER);
      this.controls[i] = this.configs[i].getControlType().addControl(this.sShell, this.configs[i].getName(), this.configs[i].getValue());
    }
    
    addOKCancelButton();
  }

  /* (non-Javadoc)
   * @see jp.co.powerbeans.websukui.swt.PBSwt#cmdOk()
   */
  public void cmdOk() {
    // 値を取得
    for (int i = 0; i < this.controls.length; i++) {
      this.configs[i].setValue(this.configs[i].getControlType().getValue(this.controls[i]));
      
      // 保存
      if (DBManager.update(this.configs[i]) == 0) {
        DBManager.insert(this.configs[i]);
      }
    }

    super.cmdOk();
  }
}
