/**
 * WebSukui
 * copyright PowerBEANS Co., Ltd.
 * create date 2006/10/05
 * amonden
 */
package jp.co.powerbeans.common.swt;

import java.lang.reflect.InvocationTargetException;

import org.apache.commons.beanutils.BeanUtils;
import org.eclipse.swt.widgets.Combo;

/**
 * PBMasterSelectComboSwt.
 * マスタの全項目を選択するコンボボックスのみの画面
 * @author amonden
 * @create date 2006/10/05
 */
public class PBMasterSelectComboSwt extends PBMiniSwt {



  private Class masterCls;
  private String message;
  private String comboLabel;
  private String showColumn;
  private Combo masterCombo;
  private Object masterSelObj;

  /**
   * @param obj 
   */
  public PBMasterSelectComboSwt(Object obj, String message, String combo_label, String show_column) {
    super();
    createSShell("Select " + obj.getClass().getSimpleName(), true);
    
    this.masterCls = obj.getClass();
    this.masterSelObj = obj;
    this.message = message;
    this.comboLabel = combo_label;
    this.showColumn = show_column;
    
    initialize();
  }
  
  /**
   * 初期化
   */
  private void initialize() {
    createComposit();
    createItems();
  }

  /**
   * Composit作成
   */
  protected void createComposit() {
    setGridLayout(2);
  }

  /**
   * 項目作成
   */
  protected void createItems() {
    
    // 1行目メッセージ
    addLabelWithColspan(message, 2);
    
    // 2行目ラベル,コンボ
    addLabel(comboLabel);
    this.masterCombo =  addComboBoxByModel("mastercmb", this.masterCls, this.showColumn, null);
    this.masterCombo.select(0);

    addOKCancelButton();
  }


  /* (non-Javadoc)
   * @see jp.co.powerbeans.websukui.swt.PBSwt#cmdOk()
   */
  @Override
  public void cmdOk() {
    
    // 選択したオブジェクトをコピー
    try {
      BeanUtils.copyProperties(this.masterSelObj, ChkConvSwt.getSelectObject(this.masterCombo));
    } catch (IllegalAccessException e) {
      e.printStackTrace();
    } catch (InvocationTargetException e) {
      e.printStackTrace();
    }
    
    super.cmdOk();
  }
  
  
}
