/**
 * $Id$
 */
package jp.co.powerbeans.common.swt;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.KeyEvent;
import org.eclipse.swt.events.KeyListener;

/**
 * ShortCutKeyListener
 * 
 * @author amonden
 * @create 2006/12/21
 */
public class ShortCutKeyListener implements KeyListener {

    /**
     * コマンド.実行するメソッド名の "cmd" 以降を表す
     */
    private String cmd;
    /**
     * コマンドディスパッチャ
     */
    private PBCmdDispatch dispacher;

  /**
   * @param swt
   * @param cmd
   */
  public ShortCutKeyListener(PBCmdDispatch dispachert, String cmd) {
    this.dispacher = dispachert;
    this.cmd = cmd;
  }

  /* (非 Javadoc)
   * @see org.eclipse.swt.events.KeyListener#keyPressed(org.eclipse.swt.events.KeyEvent)
   */
  public void keyPressed(KeyEvent e) {
    // Ctrlキーが押されていた場合は,押したキーの名称をコマンドに付加して実行
    if ((e.stateMask & SWT.CTRL) > 0) {
      this.dispacher.dispatchCmd(this.cmd + e.character, null);
    }
  }

  /* (非 Javadoc)
   * @see org.eclipse.swt.events.KeyListener#keyReleased(org.eclipse.swt.events.KeyEvent)
   */
  public void keyReleased(KeyEvent e) {
  }

}
