/**
 * $Id$
 */
package jp.co.powerbeans.kaishuj.logic;

import jp.co.powerbeans.common.db.DBManager;
import jp.co.powerbeans.common.db.DBUtil;
import jp.co.powerbeans.kaishuj.models.ClassInfo;
import jp.co.powerbeans.kaishuj.models.ConstructorInfo;
import jp.co.powerbeans.kaishuj.models.FieldInfo;
import jp.co.powerbeans.kaishuj.models.MethodInfo;

/**
 * ClassSearchMgr
 * 
 * @author amonden
 * @create 2006/12/22
 */
public class ClassSearchMgr {

  /**
   * 検索条件に一致したクラスを検索
   * @param like_part true 部分検索, false 前方一致検索
   * @return 
   */
  public static ClassInfo[] searchClasses(String keyword, boolean like_part) {
    StringBuffer where = new StringBuffer();
    
    // set keyword
    String like_part_mk = like_part ? "%" : "";
    where.append("className Like '" + like_part_mk + DBUtil.escape(keyword) +  "%'");
    
    ClassInfo[] cls_infos = (ClassInfo[]) DBManager.findBy(ClassInfo.class, where.toString());
  
    return cls_infos;
  
  }

  /**
   * コンストラクタを検索.
   * 
   * @param class_info_id
   * @return
   */
  public static ConstructorInfo[] searchConstructor(int class_info_id) {
    return (ConstructorInfo[]) DBManager.findBy(ConstructorInfo.class, "classInfoId = " + class_info_id);
  }

  /**
   * フィールドを検索
   * @param class_info_id
   * @return
   */
  public static FieldInfo[] searchFields(int class_info_id) {
    return (FieldInfo[]) DBManager.findBy(FieldInfo.class, "classInfoId = " + class_info_id);
  }

  /**
   * メソッドを検索
   * @param class_info_id
   * @return
   */
  public static MethodInfo[] searchMethods(int class_info_id) {
    return (MethodInfo[])DBManager.findBy(MethodInfo.class, "classInfoId = " + class_info_id);
  }

}
