/**
 * $Id$
 */
package jp.co.powerbeans.kaishuj.logic.parser;

import java.util.HashMap;
import java.util.Map;

/**
 * BlockParserFactory
 * 
 * @author amonden
 * @create 2006/12/21
 */
public class BlockParserFactory {

//  private static final Class[] BLOCK_PARSER = {
//    HeaderBlockParserImpl.class,
//    TitleBlockParserImpl.class,
//    ExplainBlockparserImpl.class
//  };
  private static final Map<String, Class> BLOCK_PARSER_MAP = 
    new HashMap<String, Class>();
  static {
    BLOCK_PARSER_MAP.put("default", DefaultBlockParserImpl.class);
    BLOCK_PARSER_MAP.put("START OF NAVBAR", StartOfTopNavbarBlockParserImpl.class);
    BLOCK_PARSER_MAP.put("START OF CLASS DATA", StartOfTopClassDataBlockParserImpl.class);
    BLOCK_PARSER_MAP.put("FIELD DETAIL", FieldDetailBlockParserImpl.class);
    BLOCK_PARSER_MAP.put("CONSTRUCTOR DETAIL", ConstructorDetailBlockParserImpl.class);
    BLOCK_PARSER_MAP.put("METHOD DETAIL", MethodDetailBlockParserImpl.class);
  }
  
  /**
   * @param block_name
   * @return
   */
  public static BlockParser createInstance(String block_name) {
    try {
      if (!BLOCK_PARSER_MAP.containsKey(block_name)) {
        block_name = "default";
      }
      
      Class cls = (Class) BLOCK_PARSER_MAP.get(block_name);
      return (BlockParser)cls.newInstance();
      
    } catch (Exception e) {
      throw new RuntimeException(e);
    }
  }

  /**
   * @param line
   * @return
   */
  public static boolean isNewBlock(String line) {
    return line != null && line.indexOf("<!-- ========") != -1;
  }

  /**
   * @param line
   * @return
   */
  public static String getBlockNameFromSrcHtml(String line) {
    String line_up = line.toUpperCase();
    return line_up.replaceAll("<!--", "").replaceAll("-->", "").trim().replaceAll("=", "").trim();
//    return line_up.toUpperCase().replaceAll("<!-- ========= ", "").replaceAll(" ======= -->", "").trim();
  }

}
