/**
 * $Id$
 */
package jp.co.powerbeans.kaishuj.logic.parser;

import jp.co.powerbeans.common.db.DBManager;
import jp.co.powerbeans.kaishuj.logic.ClassRemoveMgr;
import jp.co.powerbeans.kaishuj.models.ClassInfo;

/**
 * StartOfTopClassDataBlockParserImpl
 * 
 * @author amonden
 * @create 2006/12/21
 */
public class StartOfTopClassDataBlockParserImpl implements BlockParser {

  private String packageName;
  private String typeName;
  private StringBuffer expln;
  
  /* (非 Javadoc)
   * @see jp.co.powerbeans.kaishuj.logic.BlockParser#parseLine(java.lang.String)
   */
  public void parseLine(String line) {
    
    if (expln == null) {
      expln = new StringBuffer();
    }
    expln.append(line);
    
    // get package name
    if (this.packageName == null) {
      String line_up = line.toUpperCase();
      if (line_up.trim().endsWith("</FONT>")) {
        this.packageName = line.trim().substring(0, line.length() - 7);
      }
    }
    
    // get class name
    if (this.typeName == null) {
      String line_up = line.toUpperCase();
      if (line_up.startsWith("<DT>")) {
        if (line.indexOf("class") != -1) {
          this.typeName = "Class";
        } else if (line.indexOf("interface") != -1) {
          this.typeName = "Interface";
        } else if (line.indexOf("enum") != -1) {
          this.typeName = "Enum";
        }
      }
    }
  }

  /* (非 Javadoc)
   * @see jp.co.powerbeans.kaishuj.logic.BlockParser#finish(jp.co.powerbeans.kaishuj.models.ClassInfo)
   */
  public void finish(ClassInfo cls_info) {
    cls_info.setPackageName(this.packageName);
    cls_info.setTypeName(this.typeName);
    cls_info.setExplain(expln.toString());
    
    // 他のブロック(Constructor等を考慮し)ここでinsertしてしまう
    ClassRemoveMgr.removeByClassInfo(ClassInfo.class, cls_info);

    // 追加
    DBManager.insert(cls_info);
    
    // ID を再取得(指定したPKでない場合があるので)
    ClassInfo cls_info_new = (ClassInfo) DBManager.find1By(ClassInfo.class, " className = '" + cls_info.getClassName() + "' " +
            "AND javadocUrlId = " + cls_info.getJavadocUrlId() + 
            "AND packageName = '" + cls_info.getPackageName() + "'");
    cls_info.setClassInfoId(cls_info_new.getClassInfoId());
  }
}
