/**
 * $Id$
 */
package jp.co.powerbeans.kaishuj.models;

import java.io.Serializable;
import java.sql.Timestamp;

/**
 * ClassInfo
 * 
 * @author amonden
 * @create 2006/12/21
 */
public class ClassInfo implements Serializable {

  /**
   * 
   */
  private static final long serialVersionUID = 1L;
  /**
   * クラス情報ID
   */
  private int classInfoId;
  /**
   * クラス名
   */
  private String className;
  /**
   * パッケージ名
   */
  private String packageName;
  /**
   * タイプ名(Class or Interface or Enum)
   */
  private String typeName;
  /**
   * クラスの説明
   */
  private String explain;
  
  /**
   * 導入されたバージョン
   */
  private String providedVersion;
  
  /**
   * JavaDocUrl ID
   */
  private int javadocUrlId;
  
  /**
   * class の javadoc URL
   */
  private String classJavadocUrl;
  
  /**
   * 登録日時
   */
  private Timestamp createDt;
//private String defaultImplementsClass; 既知の実装クラス一覧はFK
// メソッドはFKへ
  // フィールドはFKへ

  /**
   * @return classInfoId を戻します。
   */
  public int getClassInfoId() {
    return this.classInfoId;
  }

  /**
   * @param classInfoId 設定する classInfoId。
   */
  public void setClassInfoId(int classInfoId) {
    this.classInfoId = classInfoId;
  }

  /**
   * @return className を戻します。
   */
  public String getClassName() {
    return this.className;
  }

  /**
   * @param className 設定する className。
   */
  public void setClassName(String className) {
    this.className = className;
  }

  /**
   * @return createDt を戻します。
   */
  public Timestamp getCreateDt() {
    return this.createDt;
  }

  /**
   * @param createDt 設定する createDt。
   */
  public void setCreateDt(Timestamp createDt) {
    this.createDt = createDt;
  }

  /**
   * @return explain を戻します。
   */
  public String getExplain() {
    return this.explain;
  }

  /**
   * @param explain 設定する explain。
   */
  public void setExplain(String explain) {
    this.explain = explain;
  }

  /**
   * @return packageName を戻します。
   */
  public String getPackageName() {
    return this.packageName;
  }

  /**
   * @param packageName 設定する packageName。
   */
  public void setPackageName(String packageName) {
    this.packageName = packageName;
  }

  /**
   * @return typeName を戻します。
   */
  public String getTypeName() {
    return this.typeName;
  }

  /**
   * @param typeName 設定する typeName。
   */
  public void setTypeName(String typeName) {
    this.typeName = typeName;
  }

  /**
   * @return providedVersion を戻します。
   */
  public String getProvidedVersion() {
    return this.providedVersion;
  }

  /**
   * @param providedVersion 設定する providedVersion。
   */
  public void setProvidedVersion(String providedVersion) {
    this.providedVersion = providedVersion;
  }

  /**
   * @return javadocUrlId を戻します。
   */
  public int getJavadocUrlId() {
    return this.javadocUrlId;
  }

  /**
   * @param javadocUrlId 設定する javadocUrlId。
   */
  public void setJavadocUrlId(int javadocUrlId) {
    this.javadocUrlId = javadocUrlId;
  }

  /**
   * @return classJavadocUrl を戻します。
   */
  public String getClassJavadocUrl() {
    return this.classJavadocUrl;
  }

  /**
   * @param classJavadocUrl 設定する classJavadocUrl。
   */
  public void setClassJavadocUrl(String classJavadocUrl) {
    this.classJavadocUrl = classJavadocUrl;
  }
}
