package jp.co.powerbeans.kaishuj.swt;

import jp.co.powerbeans.common.browser.BareBonesBrowserLaunch;
import jp.co.powerbeans.common.cmd.CMD;
import jp.co.powerbeans.common.db.DBUtil;
import jp.co.powerbeans.common.swt.ChkConvSwt;
import jp.co.powerbeans.common.swt.Config;
import jp.co.powerbeans.common.swt.PBSwt;
import jp.co.powerbeans.kaishuj.logic.ClassSearchMgr;
import jp.co.powerbeans.kaishuj.models.ClassInfo;
import jp.co.powerbeans.kaishuj.models.ConstructorInfo;
import jp.co.powerbeans.kaishuj.models.FieldInfo;
import jp.co.powerbeans.kaishuj.models.MethodInfo;
import jp.co.powerbeans.kaishuj.msg.Msg;

import org.eclipse.swt.SWT;
import org.eclipse.swt.browser.Browser;
import org.eclipse.swt.events.ModifyEvent;
import org.eclipse.swt.events.ModifyListener;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Table;
import org.eclipse.swt.widgets.Text;

public class ClassNaviSwt extends PBSwt implements ModifyListener  {

  private static final String TITLE = Msg.getTitleClassNavi();

  static final int WINDOW_WIDTH = 800;

  static final int WINDOW_HEIGTH = 760;

  static final int BUTTON_WIDTH = WINDOW_WIDTH;

  static final int BUTTON_HEIGTH = 50;

  private static final int COLSPAN = 8;

  private static final String[] RESULT_TABLE_COL = {"", Msg.getLblType(), Msg.getLblPackage(), Msg.getLblClassName()};

  private static final int[] RESULT_TABLE_WID = {20, 90, 300, 400};

  private static final int RESULT_TABLE_HEIGHT = 200;

  private static final String[] SEARCH_RESULT_TABLE_COL = {"", "typeName", "packageName", "className"};

  private static final String[] CONSTRUCT_TABLE_COL = {Msg.getLblConstracter(), Msg.getLblExplain()};

  private static final String[] CONSTRUCT_TABLE_PROP = {"param", "explain"};

  private static final int[] CONSTRUCT_TABLE_WID = {300,490};

  private static final String[] FIELD_TABLE_COL = {Msg.getLblField(), Msg.getLblExplain()};

  private static final String[] FIELD_TABLE_PROP = {"fieldDef", "explain"};
  
  private static final int[] FIELD_TABLE_WID = {300,490};

  private static final String[] METHOD_TABLE_COL = {Msg.getLblMethod(), Msg.getLblExplain()};

  private static final String[] METHOD_TABLE_PROP = {"methodDef", "explain"};
  
  private static final int[] METHOD_TABLE_WID = {300,490};

  private static final String[][] MENU_CMDS = {
//    {CMD.CONFIG},
    {"sel_class,0","sel_class,1","sel_class,2","sel_class,3","sel_class,4"
      ,"sel_class,5","sel_class,6","sel_class,7","sel_class,8","sel_class,9"},
    {"browse_class,0","browse_class,1","browse_class,2","browse_class,3","browse_class,4"
      ,"browse_class,5","browse_class,6","browse_class,7","browse_class,8","browse_class,9"},
  };

  private static final String[] MENU_LABELS1 = {
//    Msg.getLblConfig(), 
    Msg.getLblSelect(),
    Msg.getLblViewByBrowser()};

  private static final String[][] MENU_LABELS2 = {
//    {Msg.getLblConfig()},
    { "1" + Msg.getLblLinenum() + " Ctrl+1", "2" + Msg.getLblLinenum() + " Ctrl+2",
          "3" + Msg.getLblLinenum() + " Ctrl+3", "4" + Msg.getLblLinenum() + " Ctrl+4",
          "5" + Msg.getLblLinenum() + " Ctrl+5", "6" + Msg.getLblLinenum() + " Ctrl+6",
          "7" + Msg.getLblLinenum() + " Ctrl+7", "8" + Msg.getLblLinenum() + " Ctrl+8",
          "9" + Msg.getLblLinenum() + " Ctrl+9", "10" + Msg.getLblLinenum() + " Ctrl+0" },
    { "1" + Msg.getLblLinenum() + " Ctrl+Shift+1", "2" + Msg.getLblLinenum() + " Ctrl+Shift+2",
      "3" + Msg.getLblLinenum() + " Ctrl+Shift+3", "4" + Msg.getLblLinenum() + " Ctrl+Shift+4",
      "5" + Msg.getLblLinenum() + " Ctrl+Shift+5", "6" + Msg.getLblLinenum() + " Ctrl+Shift+6",
      "7" + Msg.getLblLinenum() + " Ctrl+Shift+7", "8" + Msg.getLblLinenum() + " Ctrl+Shift+8",
      "9" + Msg.getLblLinenum() + " Ctrl+Shift+9", "10" + Msg.getLblLinenum() + " Ctrl+Shift+0" }
  };

  private static final int[][] MENU_ACC = {
//    {SWT.CTRL + 'P'},
    {SWT.CTRL + '1',SWT.CTRL + '2',SWT.CTRL + '3',SWT.CTRL + '4',SWT.CTRL + '5',
      SWT.CTRL + '6',SWT.CTRL + '7',SWT.CTRL + '8',SWT.CTRL + '9',SWT.CTRL + '0'},
    {SWT.CTRL + SWT.SHIFT + '1',SWT.CTRL + SWT.SHIFT + '2',SWT.CTRL + SWT.SHIFT + '3',SWT.CTRL + SWT.SHIFT + '4',SWT.CTRL + SWT.SHIFT + '5',
      SWT.CTRL + SWT.SHIFT + '6',SWT.CTRL + SWT.SHIFT + '7',SWT.CTRL + SWT.SHIFT + '8',SWT.CTRL + SWT.SHIFT + '9',SWT.CTRL + SWT.SHIFT + '0'}
  };

  private Group searchCondGrp;

  private Text keywordText;

  private Combo condTypeNameCombo;

  private Group searchResultGrp;

  private Table searchResultTable;

  private Button partSearchChk;

  private Group simpleBrowserGrp;

  private Browser simpleBrowser;

  private Group resultInfoGrp;

  private Table constructTable;

  private Table fieldTable;

  private Table methodTable;

  public ClassNaviSwt() {
    super();
    initialize();
  }

  private void initialize() {
    createSShell(TITLE, WINDOW_WIDTH, WINDOW_HEIGTH, true);
    createItems();
    createMenu();
  }

  /**
   * メニュー作成
   */
  private void createMenu() {
    create2LayerMenu(MENU_LABELS1, MENU_LABELS2, MENU_CMDS, MENU_ACC);
  }

  /**
   * 
   */
  private void createItems() {
    // setGridLayout(COLSPAN);

    // 1行目 検索条件
    this.searchCondGrp = createGroupShadowEtchedOut_FILL(Msg.getLblSearchCondition(), COLSPAN, true);
    addLabel_right(this.searchCondGrp, Msg.getLblKeyword());
    this.keywordText = addTextBox(this.searchCondGrp, "keyWord");
    this.keywordText.addModifyListener(this);
    setSpan(this.keywordText, 2, 1);
    
    // 前方一致チェック
    this.partSearchChk = addCheckBox(this.searchCondGrp, Msg.getLblPartMatch());
    setCmdToButtonOnChange(this.partSearchChk, "part_sarch_change");
    
//    // 対象コンボ
//    addLabel_right(this.searchCondGrp, Msg.getLblTarget());
//    this.condTypeNameCombo = addComboBoxByModel(this.searchCondGrp, SearchCondTargetType.class, "typeName", "changeCondTarget");
//    this.condTypeNameCombo.select(0);

    // 2行目 リアルタイム検索結果
    this.searchResultGrp = createGroupShadowEtchedOut_FILL(Msg.getLblSearchResult(), COLSPAN, true);
    this.searchResultTable = addSimpleTable(this.searchResultGrp, RESULT_TABLE_COL, RESULT_TABLE_WID, COLSPAN, RESULT_TABLE_HEIGHT);
    setCmdToTableOnSelectChange(this.searchResultTable, CMD.SEL_CHANGE);
    setCmdToTableOnDoubleClick(this.searchResultTable, "search_result_dclick");
    
    // 3行目 コンストラクタ等の詳細情報をテーブル表示
    this.resultInfoGrp = createGroupShadowEtchedOut_FILL(Msg.getLblDetail(), COLSPAN, true);
    this.constructTable = addSimpleTable(this.resultInfoGrp, CONSTRUCT_TABLE_COL, CONSTRUCT_TABLE_WID, COLSPAN, 100);
    // 4行目 フィールド
    this.fieldTable = addSimpleTable(this.resultInfoGrp, FIELD_TABLE_COL, FIELD_TABLE_WID, COLSPAN, 100);
    
    // 5行目 メソッド
    this.methodTable = addSimpleTable(this.resultInfoGrp, METHOD_TABLE_COL, METHOD_TABLE_WID, COLSPAN, 200);
    
        
//    // 3行目 簡易説明ビュー(ブラウザベース?)
//    this.simpleBrowserGrp = createGroupShadowEtchedOut_FILL("内容", COLSPAN, true);
//    this.simpleBrowser = createBrowser(this.simpleBrowserGrp, COLSPAN);
    
//    this.typeInfoGrp = createGroupShadowEtchedOut_FILL("TypeInfo", COLSPAN, true);
//    this.searchResultTable = addSimpleTable(this.typeInfoGrp, SEARCH_RESULT_COL, SEARCH_RESULT_WID, COLSPAN, SEARCH_RESULT_HEIGHT);
    
    
    // 4行目 実際のブラウザ表示
    
    
    // FixME 関連クラス,コンストラクタ一覧,フィールド,メソッド一覧,サンプルコード をTabで切り替えるか
    
    // 初期値格納
    setInitValues();
    setKeyListenerShortCut(CMD.SHORTCUT_KEY);
  }


  /**
   * 
   */
  private void setInitValues() {
    // // URLリストテーブル取得
    // DBUtil.modelsToSwtTable(this.urlTable,
    // DBManager.findByAll(JavadocUrl.class), URL_TABLE_PROPS);
    //	  
  }

  public void cmdChangeCondTarget() {
    
  }

  /* (非 Javadoc)
   * @see org.eclipse.swt.events.ModifyListener#modifyText(org.eclipse.swt.events.ModifyEvent)
   */
  public void modifyText(ModifyEvent e) {
    // 検索ワード変更時
    if (e.widget == this.keywordText) {
      research();
    }
  }

  /**
   * キーワードが正常なら再検索
   */
  private void research() {
    String keyword = this.keywordText.getText();
    if (keyword.length() > 0) {
      // 検索実行
      search();
    }
  }

  /**
   * 検索実行
   */
  private void search() {
    String keyword = this.keywordText.getText();
//    SearchCondTargetType target_type = (SearchCondTargetType) ChkConvSwt.getSelectObject(this.condTypeNameCombo);
    
    // クラスを検索
    ClassInfo[] cls_infos = ClassSearchMgr.searchClasses(keyword, this.partSearchChk.getSelection());
     
    removeAllTable();
    DBUtil.modelsToSwtTable(this.searchResultTable, cls_infos, SEARCH_RESULT_TABLE_COL);
    // 行数を格納
    int item = this.searchResultTable.getItemCount();
    for (int i = 1; i <= item && i <= 10; i++) {
      this.searchResultTable.getItem(i - 1).setText(0, "" + i);
    }
    this.searchResultTable.update();
  }

  /**
   * 画面上の全テーブルを削除
   */
  private void removeAllTable() {
    this.searchResultTable.removeAll();
    this.constructTable.removeAll();
    this.fieldTable.removeAll();
    this.methodTable.removeAll();
  }
  
  /**
   * 検索結果リスト選択値変更時
   */
  public void cmdSel_change() {
    ClassInfo ci = (ClassInfo) ChkConvSwt.getSelectObject(this.searchResultTable);
    if (ci == null) {
      return;
    }
    
    updateTableByClassInfo(ci);
    
    // 簡易ブラウザに表示
//    this.simpleBrowser.setText("<HTML><BODY>" + ci.getExplain() + "</BODY></HTML>");
  }
  
  /**
   * クラス選択コマンド実行時
   * @param index
   */
  public void cmdSel_class(String index) {
    // 対象インデックスが検索結果リストに存在すれば選択
    int ind = Integer.parseInt(index);
    
    if (ind < this.searchResultTable.getItemCount()) {
      this.searchResultTable.deselectAll();
      this.searchResultTable.select(ind);
      cmdSel_change();
    }
  }
  
  public void cmdBrowse_class(String index) {
    // 対象インデックスが検索結果リストに存在すればブラウザ表示
    int ind = Integer.parseInt(index);
    
    if (ind < this.searchResultTable.getItemCount()) {
      this.searchResultTable.deselectAll();
      this.searchResultTable.select(ind);
      cmdSearch_result_dclick();
    }
  }
  
  /**
   * 正規表現チェック変更時
   */
  public void cmdPart_sarch_change() {
    research();
  }

  /**
   * 画面の表示内容をClassInfoで更新
   * @param ci
   */
  private void updateTableByClassInfo(ClassInfo ci) {
    // 1. コンストラクタ
    this.constructTable.removeAll();
    ConstructorInfo[] const_infos = ClassSearchMgr.searchConstructor(ci.getClassInfoId());
    DBUtil.modelsToSwtTable(this.constructTable, const_infos, CONSTRUCT_TABLE_PROP);
    
    // 2. フィールド
    this.fieldTable.removeAll();
    FieldInfo[] field_infos = ClassSearchMgr.searchFields(ci.getClassInfoId());
    DBUtil.modelsToSwtTable(this.fieldTable, field_infos, FIELD_TABLE_PROP);
   
    // 3. メソッド
    this.methodTable.removeAll();
    MethodInfo[] method_infos = ClassSearchMgr.searchMethods(ci.getClassInfoId());
    DBUtil.modelsToSwtTable(this.methodTable, method_infos, METHOD_TABLE_PROP);
  }
  
  /**
   * クラス検索結果テーブルをダブルクリック
   */
  public void cmdSearch_result_dclick() {
    // 該当Javadocへジャンプ
    ClassInfo cls_info = (ClassInfo) ChkConvSwt.getSelectObject(this.searchResultTable);
    if (cls_info == null) {
      return;
    }
    
    BareBonesBrowserLaunch.openURL(cls_info.getClassJavadocUrl());
  }
  
  /**
   * クラスナビ設定画面表示
   */
  public void cmdConfig() {
    ClassNaviConfigSwt config = new ClassNaviConfigSwt(this.sShell, Config.class);
    config.show();
  }
}
